/*****************************************************************************
 * $RCSfile: Generating.cc,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: jens $
 * $Date: 2002/03/21 11:51:53 $
 * $Revision: 1.6 $
 *****************************************************************************/

#include <fstream.h>
#include <iostream.h>
#include <stdlib.h>
#include <stdio.h>
#include "Generating.hh"
#include "PFieldLogger.hh"


Generating::Generating(){}

//Generating::~Generating(){}

vector<PField> Generating::parsing(char* args){
  int valuessize= 0;
  int amount;
  int BUFFER=1024;
  int learn1;
  int learn2;
  float learn3;
  vector<PField> values; 
  int resx;
  int resy;
  int zyklus;
  int playmode;
  mPoint ball;
  mPoint ownPos;
  mPoint target;
  int taktik;
  int direction;
  int action;
  int stamina;
  int mannschaftsteil;
  int spielsituation;
  mPoint opp[11];
  mPoint tm[10];
  int closest;
  ifstream fin(args, ios::in);
  if(!fin){
    cout<<"Dateifehler" <<endl;
    exit(-1);
  }
  char bufferlearn[50];
  fin.getline(bufferlearn, sizeof(bufferlearn), '#');
  amount = sscanf ( bufferlearn, "|%i|%i|%f#", &learn1, &learn2, &learn3 );
  //learn2 = 80;
  //learn3=60.0;
  
  //cout<<"LEARN2:"<<learn2<<" bufferlearn: "<<bufferlearn<<" amount: "<<amount<<endl;
  //  "%[^|]|%[^|]"
  //"%s %s %s"
  //"%i,%i,%i,%i"
  while(fin){  
    char buffer [BUFFER];
    fin.getline(buffer, sizeof(buffer), '$');
    amount = sscanf(buffer, "%i|%i|%i,%i|%i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i |%i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i %i,%i,%i,%i |%i,%i,%i|%i,%i,%i,%i|%i,%i|%i|%i|%i|%i|%i|%i|%i|$", &zyklus, &playmode, &resx, &resy, &opp[0].x, &opp[0].y, &opp[0].dir, &opp[0].unum, &opp[1].x, &opp[1].y, &opp[1].dir, &opp[1].unum, &opp[2].x, &opp[2].y, &opp[2].dir, &opp[2].unum, &opp[3].x, &opp[3].y, &opp[3].dir, &opp[3].unum, &opp[4].x, &opp[4].y, &opp[4].dir, &opp[4].unum, &opp[5].x, &opp[5].y, &opp[5].dir, &opp[5].unum, &opp[6].x, &opp[6].y, &opp[6].dir, &opp[6].unum, &opp[7].x, &opp[7].y, &opp[7].dir, &opp[7].unum, &opp[8].x, &opp[8].y, &opp[8].dir, &opp[8].unum, &opp[9].x, &opp[9].y, &opp[9].dir, &opp[9].unum, &opp[10].x, &opp[10].y, &opp[10].dir, &opp[10].unum, &tm[0].x, &tm[0].y, &tm[0].dir, &tm[0].unum, &tm[1].x, &tm[1].y, &tm[1].dir, &tm[1].unum, &tm[2].x, &tm[2].y, &tm[2].dir, &tm[2].unum, &tm[3].x, &tm[3].y, &tm[3].dir, &tm[3].unum, &tm[4].x, &tm[4].y, &tm[4].dir, &tm[4].unum, &tm[5].x, &tm[5].y, &tm[5].dir, &tm[5].unum, &tm[6].x, &tm[6].y, &tm[6].dir, &tm[6].unum, &tm[7].x, &tm[7].y, &tm[7].dir, &tm[7].unum, &tm[8].x, &tm[8].y, &tm[8].dir, &tm[8].unum, &tm[9].x, &tm[9].y, &tm[9].dir, &tm[9].unum, &ball.x, &ball.y, &ball.dir, &ownPos.x, &ownPos.y, &ownPos.dir, &ownPos.unum, &target.x, &target.y, &taktik, &direction, &action, &stamina, &mannschaftsteil, &spielsituation, &closest);
    //cout<<"Buffer: ("<<buffer<<") playmode: "<<playmode<<" amount: "<<amount <<endl;

    if(amount>-1){
      PField pf(resx, resy, zyklus, playmode, ball, ownPos, target, taktik, direction, action, stamina, mannschaftsteil, spielsituation, opp, tm, closest, learn1, learn2, learn3);
      values.push_back(pf);//reintun
      valuessize++;
      
    }
    //value[1]; rausholen
    //groesse des vectors = values.size();
  }
  return values;  
}

mPoint::mPoint(int x, int y, int dir, int unum){
  this->x=x;
  this->y=y;
  this->dir=dir;
  this->unum=unum;
}
mPoint::mPoint(){
  this->x=-1;
  this->y=-1;
  this->dir=-1;
  this->unum=-1;
}

PField::PField(int resx, int resy, int zyklus, int playmode, mPoint ball, mPoint ownPos, mPoint target, int taktik, int direction, int action, int stamina, int mannschaftsteil, int spielsituation, mPoint opp[11], mPoint tm[10], int closest, int learn1, int learn2, float learn3){
  
  this->learn1=learn1;
  this->learn2=learn2;
  this->learn3=learn3;
  this->resx=resx;
  this->resy=resy;
  this->zyklus=zyklus;
  this->playmode=playmode;
  this->ball=ball;
  this->ownPos=ownPos;
  this->target=target;
  this->taktik=taktik;
  this->direction=direction;
  this->action=action;
  this->stamina=stamina;
  this->mannschaftsteil=mannschaftsteil;
  this->spielsituation=spielsituation;
  j = 0;  
  for(int i = 0; i < 11; i++){
    if(opp[i].x>-1){
      this->opp[j]=opp[i];
      j++;
    }
    
  }
  k=0;
  for(int i = 0; i < 10; i++){ 
    if(tm[i].x>-1){
      this->tm[k]=tm[i];
      k++;
    }
  }
  this->closest = closest;
}

