/*****************************************************************************
 * $RCSfile: initpotentialloader.h,v $
 * Copyright 2001,2002 Matthias Seekamp, Andreas Daniel, Daniel Stephan,
 *                     Jens Meyer, Robert Adolph
 * 
 * This file is part of BUGSAgent2002
 *
 * BUGSAgent2002 is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * BUGSAgent2002 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with BUGSAgent2002; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *-CVS-Info:-----------------------------------------------------------------
 * Currently locked by: $Locker:  $
 *
 * Last changed:
 * ------------------------------
 * $Author: fastjack $
 * $Date: 2002/03/01 11:18:48 $
 * $Revision: 1.4 $
 *****************************************************************************

******************************************************
*                                                    *
* InitPotentialLoader                                *
*                                                    *
*                                                    *
* 25.12.2001                                         *
*                                                    *
*                                                    *
* erstellt von Andreas Daniel                        *
*                                                    *
******************************************************
 */


//*****************
// Headerdatei
// messagereader.h
// ***************

#ifndef INITPOTENTIALLOADER_H
#define INITPOTENTIALLOADER_H

#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <fstream.h>
// #include "PotentialField.hh"

class PotentialField;

class InitPotentialLoader  {

  public:

   // -------------------------------
   // void readPotentialFile(const char*)
   // Liest das Initialisierungsfile
   // und besetzt die Parameter mit
   // Grundwerten aus dem File
   // void = kein Rueckgabewert
   // const char* = bekommt den Filename (incl Path)
   // uebergeben.
   // -------------------------------
   void readPotentialFile(const char*,PotentialField*);

  private:
   char message [512] ;
   int index;


   int setInstructionValues_Init(const char*,PotentialField*);
   int getValue_Init(const char*);

   // zu Testzwecken
   // bis alle Prioriateten vorhanden sind
   void default_setBallPriority(int);


};

#endif


/*
 * $Log: initpotentialloader.h,v $
 * Revision 1.4  2002/03/01 11:18:48  fastjack
 * GPL added
 *
 * Revision 1.3  2002/02/10 12:19:14  fastjack
 * Habe die Includes angepasst, damit die Header sich so wenig wie mglich
 * gegenseitig includen. Z.T. ersetzt durch forward Deklaration. getPFEntry Methode
 * aus dem PotentialField heraus geholt und in den PFieldLogger gepackt - ist dort
 * sinniger.
 *
 * Revision 1.2  2002/01/18 19:49:38  seekamp
 * Prioritaeten werden durch Andys FileReader aus individuellen Spielertextdateien eingelesen.
 *
 * Revision 1.1  2002/01/18 13:48:59  seekamp
 * Andys Dateien InitPotentialLoader.cpp und .h eingefuegt
 *
 */

